SoRotation(3)

NAME
SoRotation - The SoRotation class specifies a rotation transformation.

SYNOPSIS

#include <Inventor/nodes/SoRotation.h>

Inherits SoTransformation.

Inherited by SoPendulum, and SoRotor.

  Public Member Functions
virtual SoType getTypeId (void) const
SoRotation (void)
virtual void doAction (SoAction *action)
virtual void GLRender (SoGLRenderAction *action)
virtual void callback (SoCallbackAction *action)
virtual void getBoundingBox (SoGetBoundingBoxAction *action)
virtual void getMatrix (SoGetMatrixAction *action)
virtual void pick (SoPickAction *action)
virtual void getPrimitiveCount (SoGetPrimitiveCountAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

  Public Attributes
SoSFRotation rotation

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoRotation ()

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoRotation class specifies a rotation transformation. Use nodes of this class type to reorient geometry data within the scene graph.

See SoTransformation class documentation for a short usage example.

FILE FORMAT/DEFAULTS:

Rotation {
    rotation 0 0 1  0
}

See also
    SbRotation, SoRotationXYZ

Constructor & Destructor Documentation

  SoRotation::SoRotation (void)
Constructor.

  SoRotation::~SoRotation () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoRotation::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoRotation::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoTransformation.

Reimplemented in SoPendulum, and SoRotor.

  const SoFieldData ** SoRotation::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoRotation::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoTransformation.

Reimplemented in SoPendulum, and SoRotor.

  void SoRotation::doAction (SoAction * action) [virtual]
This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

  void SoRotation::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

  void SoRotation::callback (SoCallbackAction * action) [virtual]
Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

  void SoRotation::getBoundingBox (SoGetBoundingBoxAction * action) [virtual]
Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculate their bounding box also override this method to change the relevant state variables.

Reimplemented from SoNode.

  void SoRotation::getMatrix (SoGetMatrixAction * action) [virtual]
Action method for SoGetMatrixAction.

Updates action by accumulating with the transformation matrix of this node (if any).

Reimplemented from SoNode.

  void SoRotation::pick (SoPickAction * action) [virtual]
Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

  void SoRotation::getPrimitiveCount (SoGetPrimitiveCountAction * action) [virtual]
Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoNode.

Member Data Documentation

  SoSFRotation SoRotation::rotation
Rotation specification. Defaults to no rotation at all. See the SbRotation documentation for instructions on how to set the value of this field.

Note that there is one very common mistake that is easy to make when setting the value of an SoSFRotation field, and that is to inadvertently use the wrong SbRotation constructor. This example should clarify the problem:

mytransformnode->rotation.setValue(0, 0, 1, 1.5707963f);

The programmer clearly tries to set a PI/2 rotation around the Z-axis, but this will fail, as the SbRotation constructor invoked above is the one that takes as arguments the 4 floats of a quaternion. What the programmer almost certainly wanted to do was to use the SbRotation constructor that takes a rotation vector and a rotation angle, which is invoked like this:

mytransformnode->rotation.setValue(SbVec3f(0, 0, 1), 1.5707963f);

Another common problem is to set the rotation value to exactly 0.0, while wanting to store just a rotation angle in the field: rotations are internally handled as quaternions, and when converting from an angle and a rotation value to a quaternion representation, the information about the angle 'gets lost' if there is no actual rotation.

Author

Generated automatically by Doxygen for Coin from the source code.